package com.xydl.cac.socket;

import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.websocket.*;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

@ServerEndpoint(value = "/websocket")
@Component
@Slf4j
public class WebSocketServer {

    private static List<Session> sessionPools = new ArrayList<>();

    @OnOpen
    public void onOpen(Session session) {
        sessionPools.add(session);
        log.info("当前连接数" + sessionPools.size());
    }

    @OnClose
    public void onClose(Session session) {
        sessionPools.remove(session);
        log.info("剩余连接数" + sessionPools.size());
    }

    public void sendMessage(String message) {
        Iterator<Session> it = sessionPools.listIterator();
        while (it.hasNext()) {
            Session session = it.next();
            try {
                session.getBasicRemote().sendText(message);
            } catch (IOException ignore) {
            }
        }
    }

    //收到客户端信息
    @OnMessage
    public void onMessage(String message) {
//        log.info("收到客户端信息:{}", message);
    }

    //错误时调用
    @OnError
    public void onError(Session session, Throwable throwable) {
    }

}
